//+------------------------------------------------------------------+
//|                                                iMa_Check.mq4     |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_buffers 3
#property indicator_color1 clrGray
#property indicator_color2 clrRed
#property indicator_color3 clrYellow
#property indicator_separate_window
#property indicator_level1 0.0

extern ENUM_TIMEFRAMES MA_TimeFrame = 0; 
extern int MA_Period = 13;
extern ENUM_MA_METHOD MA_Method = MODE_SMA;
extern ENUM_APPLIED_PRICE MA_Price  = PRICE_CLOSE; 


extern int MaMa_PerFast = 2;      
extern ENUM_MA_METHOD MaMa_MethFast = MODE_SMA;
extern int MaMa_PerSlow = 7;
extern ENUM_MA_METHOD MaMa_MethSlow = MODE_SMA;

double MaBuff[],FastBuff[],SlowBuff[],MaDiff[];


int init()
  {

   if ( MA_TimeFrame == 0 ) MA_TimeFrame = _Period;
   else {
      MaMa_PerFast = MaMa_PerFast*MA_TimeFrame/_Period;
      MaMa_PerSlow = MaMa_PerSlow*MA_TimeFrame/_Period;
   }
   IndicatorBuffers(4);
   IndicatorShortName("iMA-Check("+(string)MA_TimeFrame+"m "+(string)MA_Period+")");
   IndicatorDigits(2);
   SetIndexBuffer(0,MaDiff);
   SetIndexBuffer(1,FastBuff);
   SetIndexBuffer(2,SlowBuff);
   SetIndexBuffer(3,MaBuff);
   
   SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexStyle(1,DRAW_LINE,0,1);
   SetIndexStyle(2,DRAW_LINE,0,1);
   
   SetIndexLabel(0,"MaMa-Diff"); 
   SetIndexLabel(1,"MaMa Fast("+MaMa_PerFast+")"); 
   SetIndexLabel(2,"MaMa Slow("+MaMa_PerSlow+")"); 
   
   return(0);
}
  
int start() {
   int counted_bars=IndicatorCounted();
   int limit = Bars-counted_bars-1;
   for(int i=limit; i>=0; i--){
      int iBS = iBarShift(NULL, MA_TimeFrame, Time[i]);
      MaBuff[i] = (iMA(NULL,MA_TimeFrame,MA_Period,0,MA_Method,MA_Price,iBS) - iMA(NULL,MA_TimeFrame,MA_Period*2,0,MA_Method,MA_Price,iBS))/Point; 
   }
   for (i=limit-1;i>=0;i--){
      FastBuff[i] = (iMAOnArray(MaBuff,0,MaMa_PerFast,0,MaMa_MethFast,i));
      SlowBuff[i] = (iMAOnArray(MaBuff,0,MaMa_PerSlow,0,MaMa_MethSlow,i)); 
      MaDiff[i]   = FastBuff[i]-SlowBuff[i];
   }
//----
   return(0);
}
